// z0.h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define PRIVATE		static

#define ADD 	1
#define SUB 	2
#define INC 	3
#define DEC 	4
#define MOV 	5
#define MVI 	6
#define NOP 	7
#define PUT 	8
#define EQ 		9
#define NE 		10
#define LT 		11
#define LE 		12
#define GT 		13
#define GE 		14
#define Z	 	15
#define JMP 	16
#define JT  	17
#define JF  	18
#define STOP 	19

#define LD  	20
#define ST  	21
#define LDD  	22
#define STD  	23
#define CALL	24
#define RET		25

#define MAXMEM		20000		// memory max
#define NIL			-1

#define eqs(a,b)  (strcmp(a,b)==0)

extern int ninst;

int IRop(void);
int IRarg(void);
void run2(void);

void error(char *s);
void interp(void);
void loadprogram(char *s);
void show(void);

